(set-logic UF)

(declare-sort s 0)

(declare-fun inv1 (s) s)
(declare-fun inv2 (s) s)
(declare-fun op1 (s s) s)
(declare-fun op2 (s s) s)
(declare-fun power1 (Int s) s)
(declare-fun power2 (Int s) s)

(declare-const e1 s)
(declare-const e2 s)

; Inverse
(assert (forall ((x s)) (= (op1 (inv1 x) x) e1)))
(assert (forall ((x s)) (= (op1 x (inv1 x)) e1)))
; Identity
(assert (forall ((x s)) (= (op1 e1 x) x)))
(assert (forall ((x s)) (= x (op1 e1 x))))
; Associativity
(assert (forall ((x s) (y s) (z s)) (= (op1 x (op1 y z)) (op1 (op1 x y) z))))
; Commutativity
(assert (forall ((x s) (y s)) (= (op1 x y) (op1 y x))))
; Power
; (assert (forall ((x s)) (= (power1 0 x) e1)))
; (assert (forall ((x s) (n Int)) (= (power1 (+ n 1) x) (op1 (power1 n x) x))))
; (assert (forall ((x s) (n Int)) (=> (< n 0) (= (power1 (- n) x) (inv1 (power1 n x))))))


; Inverse
(assert (forall ((x s)) (=> (not (= x e1)) (= (op2 (inv2 x) x) e2))))
(assert (forall ((x s)) (=> (not (= x e1)) (= (op2 x (inv2 x)) e2))))
; Identity
(assert (forall ((x s)) (=> (not (= x e1)) (= (op2 e2 x) x))))
(assert (forall ((x s)) (=> (not (= x e1)) (= x (op2 e2 x)))))
; Associativity
(assert (forall ((x s) (y s) (z s)) (=> (and (not (= x e1)) (not (= y e1)) (not (= z e1))) (= (op2 x (op2 y z)) (op2 (op2 x y) z)))))
; Commutativity
(assert (forall ((x s) (y s)) (=> (and (not (= x e1)) (not (= y e1))) (= (op2 x y) (op2 y x)))))

; Distributivity
(assert (forall ((a s) (b s) (c s) (d s)) (= (op2 a (op1 b c)) (op1 (op2 a b) (op2 a c)))))
(assert (forall ((a s) (b s) (c s) (d s)) (= (op2 (op1 a b) c) (op1 (op2 a c) (op2 b c)))))

; (−a).b = −a.b
(assert-not (forall ((a s) (b s)) (exists ((z s)) (= (op2 (inv1 a) b) (inv1 z)))))
(set-option :uncomputable (inv1))

(check-sat)
